/* Program na odzkoUseni ovladani 74HC595 
ze serioveho terminalu na PC nebo tabletu
(C) 7/2023
mojeelektronika.mzf.cz
vagnervlastimil@seznam.cz
*/
#include <SoftwareSerial.h>                       // prihrani knihovny pro seriovou komunikaci 
SoftwareSerial BT=SoftwareSerial(10,11);          // nastaveni komunikacnich pinu 10=RXD, 11=TXD
const int clockPin = 2;                           // CLK PIN11 74HC595 SHCP  
const int dataPin = 3;                            // DATA PIN14 74HC595  
const int prvni = 4;                              // POVOLENI ZAPISU prvniho IO STCP PIN12
const int druhy = 5;                              // POVOLENI ZAPISU druheho IO STCP PIN12 
const int povolit = 6;                            // POVOLIT ZAPIS na VYSTUPY QA - QH PIN13
int obvod1;                                       // volba pro IO1 ovladani 74HC595 
int obvod2;                                       // volba pro IO2 ovladani 74HC595
int hodnota1;                                     // promenna pro hodnoty vystupu IO1  
int hodnota2;                                     // promenna pro hodnoty vystupu IO2
int hodnota3;                                     // promenna pro RESET obvodu IO1 a IO2

void setup(){                                     // setup
pinMode(prvni, OUTPUT);                           // nastaveni PINU na VYSTUPY
pinMode(druhy, OUTPUT);                           // nastaveni PINU na VYSTUPY
pinMode(clockPin, OUTPUT);                        // nastaveni PINU na VYSTUPY
pinMode(dataPin, OUTPUT);                         // nastaveni PINU na VYSTUPY
pinMode(povolit, OUTPUT);                         // nastaveni PINU na povoleni komunikace
BT.begin(9600);                                   // nastaveni komunikacni rychlosti
BT.println("Ovladani 74HC595");                   // nazev programu
digitalWrite(povolit, LOW);                       // vypnuti PINU6 pro ovladani PINU13 74HC595
delay(1000);                                      // casova prodleva
digitalWrite(povolit, HIGH);                      // zapnuti PINU6 pro ovladani PINU13 74HC595
delay(1000);}                                     // setup

void loop(){                                      // start loop
if (BT.available()>0){                            // testuje se vstup zda prisli data
obvod1 = BT.parseInt();                           // nactena hodnota pro zapis do IO1
hodnota1 = BT.parseInt();                         // hodnota pro zvolene zapnuti vystupu IO1
obvod2 = BT.parseInt();                           // nactena hodnota pro zapis do IO2
hodnota2 = BT.parseInt();                         // hodnota pro zvolene zapnuti vystupu IO2 
hodnota3 = BT.parseInt();                         // hodnota pro reset IO1 a IO2
if (obvod1 == 1){                                 // pokud je hodnota "1" pokracuje program dalsim radku
digitalWrite(prvni, LOW);                         // vypnuti vstupu STCP PIN12 IO1 74HC595 pro umozneni zapisu dat na vystupy 74HC595 
shiftOut(dataPin, clockPin, MSBFIRST, hodnota1);  // odeslani hodnoty na vystup 74HC595
digitalWrite(prvni, HIGH);                        // zapnuti vstupu STCP PINU112 IO1 74HC595 pro potvrzeni dat na vystupy 74HC595
BT.print("IO1 zadana hodnota = ");                // nadpis pro zobrazeni hodnoty IO1 na PC nebo tabletu
BT.println(hodnota1);                             // zobrazeni nactene hodnoty z PC nebo tabletu
hodnota1 = 0;                                     // do pormenne hodnota1 se ulozi hodnota "0"
}                                                 // konec smycky IF 
if (obvod2 == 2){                                 // pokud je hodnota "1" pokracuje program dalsim radku
digitalWrite(druhy, LOW);                         // vypnuti vstupu STCP PIN12 IO2 74HC595 pro umozneni zapisu dat na vystupy 74HC595 
shiftOut(dataPin, clockPin, MSBFIRST, hodnota2);  // odeslani hodnoty na vystup 74HC595
digitalWrite(druhy, HIGH);                        // zapnuti vstupu STCP PINU112 IO2 74HC595 pro potvrzeni dat na vystupy 74HC595
BT.print("IO2 zadana hodnota = ");                // nadpis pro zobrazeni hodnoty IO2 na PC nebo tabletu  
BT.println(hodnota2);                             // zobrazeni nactene hodnoty z PC nebo tabletu
hodnota2 = 0;                                     // do pormenne hodnota2 se ulozi hodnota "0"
}                                                 // konec smycky IF 
if (hodnota3 == 500 ){                            // pokud je hodnota3 rovna "500" pokracuje program na dalsim radku
hodnota1 = 0;                                     // do promenne hodnota1 se ulozi "0"
digitalWrite(prvni, LOW);                         // vypnuti vstupu STCP PIN12 IO1 74HC595 pro umozneni zapisu dat na vystupy 74HC595 
shiftOut(dataPin, clockPin, MSBFIRST, hodnota1);  // odeslani hodnoty na vystup 74HC595
digitalWrite(prvni, HIGH);                        // zapnuti vstupu STCP PINU112 IO1 74HC595 pro potvrzeni dat na vystupy 74HC595
delay(500);                                       // casova prodleva
hodnota2 = 0;                                     // do promenne hodnota2 se ulozi "0"
digitalWrite(druhy, LOW);                         // vypnuti vstupu STCP PIN12 IO2 74HC595 pro umozneni zapisu dat na vystupy 74HC595 
shiftOut(dataPin, clockPin, MSBFIRST, hodnota2);  // odeslani hodnoty na vystup 74HC595
digitalWrite(druhy, HIGH);                        // zapnuti vstupu STCP PINU112 IO2 74HC595 pro potvrzeni dat na vystupy 74HC595
BT.println("reset IO1 a IO2");                    // zobrazeni na monitoru PC nebo tabletu provedeni "RESETU"  
}                                                 // konec smycky IF "hodnota3 resetu
}                                                 // konec smycky IF "nacitani hodnot
delay(2000);                                      // casova prodleva pred dalsim nacitanim a pohybem serv
}                                                 // konec loop
